



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Gson全解析（中）-TypeAdapter的使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Gson全解析（中）-TypeAdapter的使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 14:36:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>TypeAdapter介绍</h1>
<p>前面的<a href="http://www.jianshu.com/p/fc5c9cdf3aab" rel="external nofollow noreferrer">Gson全解析（上）</a>中我们理解并分别运用了JsonSerializer和JsonDeserializer进行JSON和java实体类之间的相互转化。这里利用<code>TypeAdapter</code>来更加高效的完成这个需求。</p>
<p>之前在上一篇文中提到的<code>JsonSerializer</code><br />和<code>JsonDeserializer</code>解析的时候都利用到了一个中间件-<code>JsonElement</code>，比如下方的序列化过程。可以看到我们在把Java对象转化为JSON字符串的时候都会用到这个中间件<code>JsonElement</code></p>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/1833901-12690f3efa278fe0.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>JsonElement作为解析的中间层</div>
</div>
<p>而<code>TypeAdapter</code>的使用正是去掉了这个中间层，直接用流来解析数据，极大程度上提高了解析效率。</p>
<blockquote><p>New applications should prefer TypeAdapter, whose streaming API is more efficient than this interface&rsquo;s tree API.<br />应用中应当尽量使用<code>TypeAdapter</code>，它流式的API相比于之前的树形解析API将会更加高效。</p></blockquote>
<p><code>TypeAdapter</code>作为一个抽象类提供两个抽象方法。分别是<code>write()</code>和<code>read()</code>方法,也对应着序列化和反序列化。如下图所示：</p>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/1833901-a715e8b9c05b2a94.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></div>
<p>下面就让我们来一起使用和了解TypeAdapter吧：</p>
<hr />
<h1>TypeAdapter实例</h1>
<p>为了便于理解，这里还是统 一 一 下，采用和上面一篇文章同样的例子。<br /><code>Book.java</code>实体类：</p>
<pre class="prettyprint linenums"><code>package com.javacreed.examples.gson.part1;

public class Book {

  private String[] authors;<br />
  private String isbn;<br />
  private String title;

//为了代码简洁，这里移除getter和setter方法等<br />
}</code></pre>
<p>直接贴代码，具体序列化和反序列化的<code>TypeAdapter</code>类，这里是<code>BookTypeAdapter.java</code>：</p>
<pre class="prettyprint linenums"><code>package com.javacreed.examples.gson.part1;

import java.io.IOException;

import org.apache.commons.lang3.StringUtils;

import com.google.gson.TypeAdapter;<br />
import com.google.gson.stream.JsonReader;<br />
import com.google.gson.stream.JsonWriter;

public class BookTypeAdapter extends TypeAdapter {

  @Override<br />
  public Book read(final JsonReader in) throws IOException {<br />
    final Book book = new Book();

    in.beginObject();<br />
    while (in.hasNext()) {<br />
      switch (in.nextName()) {<br />
      case "isbn":<br />
        book.setIsbn(in.nextString());<br />
        break;<br />
      case "title":<br />
        book.setTitle(in.nextString());<br />
        break;<br />
      case "authors":<br />
        book.setAuthors(in.nextString().split(";"));<br />
        break;<br />
      }<br />
    }<br />
    in.endObject();

    return book;<br />
  }

  @Override<br />
  public void write(final JsonWriter out, final Book book) throws IOException {<br />
    out.beginObject();<br />
    out.name("isbn").value(book.getIsbn());<br />
    out.name("title").value(book.getTitle());<br />
    out.name("authors").value(StringUtils.join(book.getAuthors(), ";"));<br />
    out.endObject();<br />
  }<br />
}</code></pre>
<p>同样这里设置<code>TypeAdapter</code>之后还是需要配置（注册）,可以注意到的是<code>gsonBuilder.registerTypeAdapter(xxx)</code>方法进行注册在我们之前的<code>JsonSerializer</code>和<code>JsonDeserializer</code>中也有使用：</p>
<pre class="prettyprint linenums"><code>    final GsonBuilder gsonBuilder = new GsonBuilder();<br />
    gsonBuilder.registerTypeAdapter(Book.class, new BookTypeAdapter());<br />
    final Gson gson = gsonBuilder.create();</code></pre>
<p>下面对两个write方法和read方法进行分别的阐述：</p>
<h5>1 TypeAdapter中的write方法</h5>
<p><code>write()</code>方法中会传入<code>JsonWriter</code>，和需要被序列化的<code>Book</code>对象的实例，采用和<code>PrintStream</code>类似的方式 写入到<code>JsonWriter</code>中。</p>
<pre class="prettyprint linenums"><code>  @Override<br />
  public void write(final JsonWriter out, final Book book) throws IOException {<br />
    out.beginObject();<br />
    out.name("isbn").value(book.getIsbn());<br />
    out.name("title").value(book.getTitle());<br />
    out.name("authors").value(StringUtils.join(book.getAuthors(), ";"));<br />
    out.endObject();<br />
  }</code></pre>
<p>下面是上面代码的步骤：</p>
<ul><li><code>out.beginObject()</code>产生<code>{</code>,如果我们希望产生的是一个数组对象，对应的使用<code>beginArray()</code></li>
<li><code>out.name("isbn").value(book.getIsbn()); out.name("title").value(book.getTitle());</code>分别获取book中的isbn和title字段并且设置给Json对象中的isbn和title。也就是说上面这段代码，会在json对象中产生：
<pre class="prettyprint linenums"><code>"isbn": "978-0321336781",<br />
"title": "Java Puzzlers: Traps, Pitfalls, and Corner Cases",</code></pre></li>
<li><code>out.name("authors").value(StringUtils.join(book.getAuthors(), ";"));</code>则会对应着：
<pre class="prettyprint linenums"><code>"authors": "Joshua Bloch;Neal Gafter"</code></pre></li>
<li>同理&nbsp;<code>out.endObject()</code>则对应着<code>}</code></li>
<li>那么整个上面的代码也就会产生JSON对象：
<pre class="prettyprint linenums"><code>{<br />
"isbn": "978-0321336781",<br />
"title": "Java Puzzlers: Traps, Pitfalls, and Corner Cases",<br />
"authors": "Joshua Bloch;Neal Gafter"<br />
}</code></pre></li>
<li><blockquote><p>这里需要注意的是，如果没有调用&nbsp;<code>out.endObject()</code>产生<code>}</code>,那么你的项目会报出&nbsp;<code>JsonSyntaxException</code>错误</p>
<pre class="prettyprint linenums"><code>Exception in thread "main" com.google.gson.JsonSyntaxException: java.io.EOFException: End of input at line 4 column 40<br />
  at com.google.gson.Gson.fromJson(Gson.java:813)<br />
  at com.google.gson.Gson.fromJson(Gson.java:768)<br />
  at com.google.gson.Gson.fromJson(Gson.java:717)<br />
  at com.google.gson.Gson.fromJson(Gson.java:689)<br />
  at com.javacreed.examples.gson.part1.Main.main(Main.java:41)<br />
Caused by: java.io.EOFException: End of input at line 4 column 40<br />
  at com.google.gson.stream.JsonReader.nextNonWhitespace(JsonReader.java:1377)<br />
  at com.google.gson.stream.JsonReader.doPeek(JsonReader.java:471)<br />
  at com.google.gson.stream.JsonReader.hasNext(JsonReader.java:403)<br />
  at com.javacreed.examples.gson.part1.BookTypeAdapter.read(BookTypeAdapter.java:33)<br />
  at com.javacreed.examples.gson.part1.BookTypeAdapter.read(BookTypeAdapter.java:1)<br />
  at com.google.gson.Gson.fromJson(Gson.java:803)<br />
  ... 4 more</code></pre></blockquote></li></ul>
<h5>2 TypeAdapter中的read方法</h5>
<p><code>read()</code>方法将会传入一个<code>JsonReader</code>对象实例并返回反序列化的对象。</p>
<pre class="prettyprint linenums"><code>  @Override<br />
  public Book read(final JsonReader in) throws IOException {<br />
    final Book book = new Book();

    in.beginObject();<br />
    while (in.hasNext()) {<br />
      switch (in.nextName()) {<br />
      case "isbn":<br />
        book.setIsbn(in.nextString());<br />
        break;<br />
      case "title":<br />
        book.setTitle(in.nextString());<br />
        break;<br />
      case "authors":<br />
        book.setAuthors(in.nextString().split(";"));<br />
        break;<br />
      }<br />
    }<br />
    in.endObject();

    return book;<br />
  }</code></pre>
<p>下面是这段代码的步骤：</p>
<ul><li>同样是通过<code>in.beginObject();</code>和<code>in.endObject();</code>对应解析<code>{</code>,<code>}</code></li>
<li>通过
<pre class="prettyprint linenums"><code>  while (in.hasNext()) {<br />
    switch (in.nextName()) {<br />
    }<br />
  }</code></pre>
<p>来完成每个<code>JsonElement</code>的遍历,并且通过<code>switch...case</code>的方法获取Json对象中的键值对。并通过我们<code>Book实体类</code>的<code>Setter</code>方法进行设置。</li>
<li><pre class="prettyprint linenums"><code>  while (in.hasNext()) {<br />
    switch (in.nextName()) {<br />
    case "isbn":<br />
      book.setIsbn(in.nextString());<br />
      break;<br />
    case "title":<br />
      book.setTitle(in.nextString());<br />
      break;<br />
    case "authors":<br />
      book.setAuthors(in.nextString().split(";"));<br />
      break;<br />
    }<br />
  }</code></pre></li>
<li><blockquote><p>同样需要注意的是,如果没有执行<code>in.endObject()</code>，将会出现<code>JsonIOException</code>的错误：</p>
<pre class="prettyprint linenums"><code>Exception in thread "main" com.google.gson.JsonIOException: JSON document was not fully consumed.<br />
  at com.google.gson.Gson.assertFullConsumption(Gson.java:776)<br />
  at com.google.gson.Gson.fromJson(Gson.java:769)<br />
  at com.google.gson.Gson.fromJson(Gson.java:717)<br />
  at com.google.gson.Gson.fromJson(Gson.java:689)<br />
  at com.javacreed.examples.gson.part1.Main.main(Main.java:41)</code></pre></blockquote></li></ul>
<p>下面给出使用<code>TypeAdapter</code>的完整代码：</p>
<pre class="prettyprint linenums"><code>package com.javacreed.examples.gson.part1;

import java.io.IOException;

import com.google.gson.Gson;<br />
import com.google.gson.GsonBuilder;

public class Main {<br />
  public static void main(final String[] args) throws IOException {<br />
    final GsonBuilder gsonBuilder = new GsonBuilder();<br />
    gsonBuilder.registerTypeAdapter(Book.class, new BookTypeAdapter());<br />
    gsonBuilder.setPrettyPrinting();

    final Gson gson = gsonBuilder.create();

    final Book book = new Book();<br />
    book.setAuthors(new String[] { "Joshua Bloch", "Neal Gafter" });<br />
    book.setTitle("Java Puzzlers: Traps, Pitfalls, and Corner Cases");<br />
    book.setIsbn("978-0321336781");

    final String json = gson.toJson(book);<br />
    System.out.println("Serialised");<br />
    System.out.println(json);

    final Book parsedBook = gson.fromJson(json, Book.class);<br />
    System.out.println("\nDeserialised");<br />
    System.out.println(parsedBook);<br />
  }<br />
}</code></pre>
<p>对应的编译结果为：</p>
<pre class="prettyprint linenums"><code>Serialised<br />
{<br />
  "isbn": "978-0321336781",<br />
  "title": "Java Puzzlers: Traps, Pitfalls, and Corner Cases",<br />
  "authors": "Joshua Bloch;Neal Gafter"<br />
}

Deserialised<br />
Java Puzzlers: Traps, Pitfalls, and Corner Cases [978-0321336781]<br />
Written by:<br />
  &gt;&gt; Joshua Bloch<br />
  &gt;&gt; Neal Gafter</code></pre>
<hr />
<h1>TypeAdapter处理简洁的JSON数据</h1>
<p>为了简化JSON数据，其实我们上面的JSON数据可以这么写：</p>
<pre class="prettyprint linenums"><code>["978-0321336781","Java Puzzlers: Traps, Pitfalls, and Corner Cases","Joshua Bloch","Neal Gafter"]</code></pre>
<p>可以看到的是，这样采用的直接是值的形式。当然这样操作简化了JSON数据但是可能就让整个数据的稳定性下降了许多的，你需要按照一定的顺序来解析这个数据。<br />对应的<code>write</code>和<code>read</code>方法如下：</p>
<pre class="prettyprint linenums"><code>  @Override<br />
  public void write(final JsonWriter out, final Book book) throws IOException {<br />
    out.beginArray();<br />
    out.value(book.getIsbn());<br />
    out.value(book.getTitle());<br />
    for (final String author : book.getAuthors()) {<br />
      out.value(author);<br />
    }<br />
    out.endArray();<br />
  }</code></pre>
<pre class="prettyprint linenums"><code>  @Override<br />
  public Book read(final JsonReader in) throws IOException {<br />
    final Book book = new Book();

    in.beginArray();<br />
    book.setIsbn(in.nextString());<br />
    book.setTitle(in.nextString());<br />
    final List authors = new ArrayList&lt;&gt;();<br />
    while (in.hasNext()) {<br />
      authors.add(in.nextString());<br />
    }<br />
    book.setAuthors(authors.toArray(new String[authors.size()]));<br />
    in.endArray();

    return book;<br />
  }</code></pre>
<p>这里的解析原理和上面一致，不再赘述。</p>
<hr />
<h1>TypeAdapter解析内置对象</h1>
<p>（这里将nested objects翻译为内置对象，其实就是在Book类）</p>
<p>这里对上面的Book实体类进行修改如下，添加Author作者类，每本书可以有多个作者。</p>
<pre class="prettyprint linenums"><code>package com.javacreed.examples.gson.part3;

public class Book {

  private Author[] authors;<br />
  private String isbn;<br />
  private String title;

class Author {

  private int id;<br />
  private String name;

//为了代码简洁，这里移除getter和setter方法等<br />
}<br />
//为了代码简洁，这里移除getter和setter方法等<br />
}</code></pre>
<p>这里提供JSON对象，</p>
<pre class="prettyprint linenums"><code>{<br />
  "isbn": "978-0321336781",<br />
  "title": "Java Puzzlers: Traps, Pitfalls, and Corner Cases",<br />
  "authors": [<br />
    {<br />
      "id": 1,<br />
      "name": "Joshua Bloch"<br />
    },<br />
    {<br />
      "id": 2,<br />
      "name": "Neal Gafter"<br />
    }<br />
  ]<br />
}</code></pre>
<p>下面分别展示write和read方法：</p>
<pre class="prettyprint linenums"><code>  @Override<br />
  public void write(final JsonWriter out, final Book book) throws IOException {<br />
    out.beginObject();<br />
    out.name("isbn").value(book.getIsbn());<br />
    out.name("title").value(book.getTitle());<br />
    out.name("authors").beginArray();<br />
    for (final Author author : book.getAuthors()) {<br />
      out.beginObject();<br />
      out.name("id").value(author.getId());<br />
      out.name("name").value(author.getName());<br />
      out.endObject();<br />
    }<br />
    out.endArray();<br />
    out.endObject();<br />
  }</code></pre>
<pre class="prettyprint linenums"><code> @Override<br />
  public Book read(final JsonReader in) throws IOException {<br />
    final Book book = new Book();

    in.beginObject();<br />
    while (in.hasNext()) {<br />
      switch (in.nextName()) {<br />
      case "isbn":<br />
        book.setIsbn(in.nextString());<br />
        break;<br />
      case "title":<br />
        book.setTitle(in.nextString());<br />
        break;<br />
      case "authors":<br />
        in.beginArray();<br />
        final List authors = new ArrayList&lt;&gt;();<br />
        while (in.hasNext()) {<br />
          in.beginObject();<br />
          final Author author = new Author();<br />
          while (in.hasNext()) {<br />
            switch (in.nextName()) {<br />
            case "id":<br />
              author.setId(in.nextInt());<br />
              break;<br />
            case "name":<br />
              author.setName(in.nextString());<br />
              break;<br />
            }<br />
          }<br />
          authors.add(author);<br />
          in.endObject();<br />
        }<br />
        book.setAuthors(authors.toArray(new Author[authors.size()]));<br />
        in.endArray();<br />
        break;<br />
      }<br />
    }<br />
    in.endObject();

    return book;<br />
  }</code></pre>
<hr />
<h1>总结</h1>
<p>TypeAdapter对JSON和Java对象之间的序列化和反序列化可以通过上面的方法进行操作。其实在解决解析内置对象的序列化和反序列化的时候我们也可以通过JsonDeserializer或者JsonSerializer进行操作，序列化过程如下：</p>
<pre class="prettyprint linenums"><code>@Override<br />
  public JsonElement serialize(final Book book, final Type typeOfSrc, final JsonSerializationContext context) {<br />
    final JsonObject jsonObject = new JsonObject();<br />
    jsonObject.addProperty("isbn", book.getIsbn());<br />
    jsonObject.addProperty("title", book.getTitle());

    final JsonElement jsonAuthros = context.serialize(book.getAuthors());<br />
    jsonObject.add("authors", jsonAuthros);

    return jsonObject;<br />
  }</code></pre>
<p>这里通过<code>JsonSerializationContext</code>提供的context对象直接解析，一定程度上提供了JSON对象序列化（反序列化）的一致性。</p>
<hr />
<h1>参考链接</h1>
<p>翻译原文，根据原文做出了较大改动。<br />1&nbsp;<a href="http://www.javacreed.com/simple-gson-example/" rel="external nofollow noreferrer">SIMPLE GSON EXAMPLE</a><br />2&nbsp;<a href="http://www.javacreed.com/gson-deserialiser-example/" rel="external nofollow noreferrer">GSON DESERIALISER EXAMPLE</a><br />3&nbsp;<a href="http://www.javacreed.com/gson-annotations-example/" rel="external nofollow noreferrer">GSON ANNOTATIONS EXAMPLE</a><br />4&nbsp;<a href="http://www.javacreed.com/gson-serialiser-example/" rel="external nofollow noreferrer">GSON SERIALISER EXAMPLE</a><br />5&nbsp;<a href="http://www.javacreed.com/gson-typeadapter-example/" rel="external nofollow noreferrer">GSON TYPEADAPTER EXAMPLE</a><br />6&nbsp;<a href="http://www.javacreed.com/gson-typeadapter-example-serialise-large-objects/" rel="external nofollow noreferrer">GSON TYPEADAPTER EXAMPLE SERIALISE LARGE OBJECTS</a></p>
<p>另附：&nbsp;<a href="http://www.jianshu.com/p/e740196225a4" rel="external nofollow noreferrer">你真的会用Gson吗?Gson使用指南（一）</a>系列文章</p>
<p>更多及时技术资讯，欢迎关注我的微博 ：<a href="http://weibo.com/u/3288332304" rel="external nofollow noreferrer">Anthony</a></p>
<p>gson github地址<a href="https://github.com/google" rel="external nofollow noreferrer">google</a>/<a href="https://github.com/google/gson" rel="external nofollow noreferrer">gson</a></p>
<p>本篇文章是基于Gson官方使用指导(<a href="https://github.com/google/gson/blob/master/UserGuide.md" rel="external nofollow noreferrer">Gson User Guide</a>)以及Gson解析的优秀外文（来自<a href="http://www.javacreed.com/" rel="external nofollow noreferrer">http://www.javacreed.com/</a>&nbsp;）做出的一个翻译和归纳。<br />博客原链接：<br /><a href="http://www.jianshu.com/p/fc5c9cdf3aab" rel="external nofollow noreferrer">Gson全解析（上）-Gson基础</a><br /><a href="http://www.jianshu.com/p/8cc857583ff4" rel="external nofollow noreferrer">Gson全解析（中）-TypeAdapter的使用</a><br /><a href="http://www.jianshu.com/p/17a68d4fffbe" rel="external nofollow noreferrer">Gson全解析（下）-Gson性能分析</a></p>
<p>from:&nbsp;http://www.jianshu.com/p/8cc857583ff4</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4wvl39.html">mysql数据库添加索引优化查询效率</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdmm4xq.html">ios  clang&colon; error&colon; linker command failed with exit code 1 &lpar;use -v to see invocation&rpar;解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wd13lq.html">Codeforces Round &num;337  Alphabet Permutations</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j01pz4q.html">rails里routes配置文件里的resources和resource的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnov108.html">WinForm设置窗体默认控件焦点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnvez6q.html">TransactionScope事务</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjol079.html">Swift - 07 - 布尔类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn7lwd8.html">&lowbar;js day12</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o6k6v9.html">一些tcp通讯代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp1vl59.html">我工作这几年（五）-- Android学习4&period;5月总结（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkkj1v8.html">使用更清晰DebugLog开发和调试工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m46z38.html">JSP静态化（伪静态）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy10degq.html">Javascript从&OpenCurlyDoubleQuote;繁&rdquo;到&OpenCurlyDoubleQuote;简&rdquo;进行数组去重</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdeeny9.html">Linux下如何释放cache内存</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mez5nrq.html">linux监控下几个系统工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojexylq.html">centos7&period;2下部署 python3</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ovpwq.html">CUDA error 100 &amp;amp&semi; Decoder not initialized</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4poek0q.html">【SSH网上商城项目实战15】线程、定时器同步首页数据（类似于博客定期更新排名）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj104p8.html">【Linux笔记】CentOS yum 安装 vsftpd</a>
		</li>
						<li><a href="https://www.batexi.com/a/902ool3q.html">js处理url</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnvkovk8.html">Clipboard深度实践与采坑记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wlzdwq.html">STM32应用实例五：与SHT1X温湿度传感器通讯</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdr7lz9.html">ambari下的flume和kafka整合</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyylezxq.html">DNS java</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1pnkxq.html">&lbrack;转&rsqb; react-router4 实现按需加载</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyndwxq.html">Linux与Windows中的UTC时间</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25ewxvq.html">新建asp&period;net core项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j5y0jq.html">BZOJ3673 可持久化并查集 by zky 可持久化 并查集</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25ej5vq.html">What Are You Talking About HDU1075</a>
			</li>
						<li><a href="https://www.batexi.com/a/96020vv9.html">hdu1873 看病要排队【优先队列】</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
